# Currently supported operations

Minimal tested opset version 9, maximum tested opset version 15, recommended opset version 13

| Operation type            | Supported | Restrictions                                                                                                                                                        |
|---------------------------|-----------|---------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| Abs                       | Y         |                                                                                                                                                                     |
| Acos                      | Y         |                                                                                                                                                                     |
| Acosh                     | N         |                                                                                                                                                                     |
| Add                       | Y         |                                                                                                                                                                     |
| And                       | Y         |                                                                                                                                                                     |
| ArgMax                    | N         |                                                                                                                                                                     |
| ArgMin                    | N         |                                                                                                                                                                     |
| Asin                      | Y         |                                                                                                                                                                     |
| Asinh                     | N         |                                                                                                                                                                     |
| Atan                      | Y         |                                                                                                                                                                     |
| Atanh                     | N         |                                                                                                                                                                     |
| AveragePool               | Y         | Average pool operation with spatial rank > 3 is not implemented                                                                                                     |
| BatchNormalization        | Y         | BatchNorm operation with spatial rank > 3 is not implemented. BatchNorm nodes in training mode are not supported                                                    |
| BitShift                  | N         |                                                                                                                                                                     |
| Cast                      | Y         |                                                                                                                                                                     |
| Ceil                      | Y         |                                                                                                                                                                     |
| Clip                      | Y         | Dynamic value of min/max is not implemented                                                                                                                         |
| Compress                  | N         |                                                                                                                                                                     |
| Concat                    | Y         |                                                                                                                                                                     |
| ConcatFromSequence        | N         |                                                                                                                                                                     |
| Constant                  | Y         |                                                                                                                                                                     |
| ConstantOfShape           | Y         | Parameter "value" must be scalar                                                                                                                                    |
| Conv                      | Y         | Convolution operation with spatial rank > 3 is not implemented                                                                                                      |
| ConvInteger               | N         |                                                                                                                                                                     |
| ConvTranspose             | Y         | Convolution operation with spatial rank > 3 is not implemented                                                                                                      |
| Cos                       | Y         |                                                                                                                                                                     |
| Cosh                      | N         |                                                                                                                                                                     |
| CumSum                    | Y         |                                                                                                                                                                     |
| DepthToSpace              | N         |                                                                                                                                                                     |
| DequantizeLinear          | N         |                                                                                                                                                                     |
| Det                       | N         |                                                                                                                                                                     |
| Div                       | Y         |                                                                                                                                                                     |
| Dropout                   | Y         |                                                                                                                                                                     |
| Einsum                    | Y         |                                                                                                                                                                     |
| Elu                       | Y         |                                                                                                                                                                     |
| Equal                     | Y         |                                                                                                                                                                     |
| Erf                       | Y         |                                                                                                                                                                     |
| Exp                       | Y         |                                                                                                                                                                     |
| Expand                    | Y         |                                                                                                                                                                     |
| EyeLike                   | N         |                                                                                                                                                                     |
| Flatten                   | Y         |                                                                                                                                                                     |
| Floor                     | Y         |                                                                                                                                                                     |
| GRU                       | N         |                                                                                                                                                                     |
| Gather                    | Y         |                                                                                                                                                                     |
| GatherElements            | Y         |                                                                                                                                                                     |
| GatherND                  | N         |                                                                                                                                                                     |
| Gemm                      | Y         |                                                                                                                                                                     |
| GlobalAveragePool         | Y         |                                                                                                                                                                     |
| GlobalLpPool              | N         |                                                                                                                                                                     |
| GlobalMaxPool             | N         |                                                                                                                                                                     |
| Greater                   | Y         |                                                                                                                                                                     |
| GridSample                | N         |                                                                                                                                                                     |
| HardSigmoid               | Y         |                                                                                                                                                                     |
| Hardmax                   | N         |                                                                                                                                                                     |
| Identity                  | Y         |                                                                                                                                                                     |
| If                        | N         |                                                                                                                                                                     |
| InstanceNormalization     | N         |                                                                                                                                                                     |
| IsInf                     | N         |                                                                                                                                                                     |
| IsNaN                     | N         |                                                                                                                                                                     |
| LRN                       | Y         |                                                                                                                                                                     |
| LSTM                      | N         |                                                                                                                                                                     |
| LeakyRelu                 | Y         |                                                                                                                                                                     |
| Less                      | Y         |                                                                                                                                                                     |
| Log                       | Y         |                                                                                                                                                                     |
| Loop                      | N         |                                                                                                                                                                     |
| LpNormalization           | N         |                                                                                                                                                                     |
| LpPool                    | N         |                                                                                                                                                                     |
| MatMul                    | Y         |                                                                                                                                                                     |
| MatMulInteger             | N         |                                                                                                                                                                     |
| Max                       | Y         |                                                                                                                                                                     |
| MaxPool                   | Y         | Max pool operation with spatial rank > 3 is not implemented                                                                                                         |
| MaxRoiPool                | N         |                                                                                                                                                                     |
| MaxUnpool                 | N         |                                                                                                                                                                     |
| Mean                      | Y         |                                                                                                                                                                     |
| Min                       | Y         |                                                                                                                                                                     |
| Mod                       | N         |                                                                                                                                                                     |
| Mul                       | Y         |                                                                                                                                                                     |
| Multinomial               | N         |                                                                                                                                                                     |
| Neg                       | Y         |                                                                                                                                                                     |
| NonMaxSuppression         | Y         |                                                                                                                                                                     |
| NonZero                   | N         |                                                                                                                                                                     |
| Not                       | Y         |                                                                                                                                                                     |
| OneHot                    | N         |                                                                                                                                                                     |
| Optional                  | N         |                                                                                                                                                                     |
| OptionalGetElement        | N         |                                                                                                                                                                     |
| OptionalHasElement        | N         |                                                                                                                                                                     |
| Or                        | Y         |                                                                                                                                                                     |
| PRelu                     | Y         |                                                                                                                                                                     |
| Pad                       | Y         | Padding is implemented to pad the last 3 dimensions of 5D input tensor, or the last 2 dimensions of 4D input tensor, or the last dimension of 3D input tensor       |
| Pow                       | Y         |                                                                                                                                                                     |
| QLinearConv               | N         |                                                                                                                                                                     |
| QLinearMatMul             | N         |                                                                                                                                                                     |
| QuantizeLinear            | N         |                                                                                                                                                                     |
| RNN                       | N         |                                                                                                                                                                     |
| RandomNormal              | N         |                                                                                                                                                                     |
| RandomNormalLike          | N         |                                                                                                                                                                     |
| RandomUniform             | N         |                                                                                                                                                                     |
| RandomUniformLike         | N         |                                                                                                                                                                     |
| Reciprocal                | Y         |                                                                                                                                                                     |
| ReduceL1                  | Y         |                                                                                                                                                                     |
| ReduceL2                  | Y         |                                                                                                                                                                     |
| ReduceLogSum              | Y         |                                                                                                                                                                     |
| ReduceLogSumExp           | Y         |                                                                                                                                                                     |
| ReduceMax                 | Y         |                                                                                                                                                                     |
| ReduceMean                | Y         |                                                                                                                                                                     |
| ReduceMin                 | Y         |                                                                                                                                                                     |
| ReduceProd                | Y         |                                                                                                                                                                     |
| ReduceSum                 | Y         |                                                                                                                                                                     |
| ReduceSumSquare           | Y         |                                                                                                                                                                     |
| Relu                      | Y         |                                                                                                                                                                     |
| Reshape                   | Y         | Parameter "allowzero" = 1 is not implemented                                                                                                                        |
| Resize                    | Y         | Roi logic is not implemented (pytorch's interpolate cannot resize channel or batch dimensions)                                                                      |
| ReverseSequence           | N         |                                                                                                                                                                     |
| RoiAlign                  | Y         | Only "avg" mode is supported                                                                                                                                        |
| Round                     | Y         |                                                                                                                                                                     |
| Scan                      | N         |                                                                                                                                                                     |
| Scatter(deprecated)       | N         |                                                                                                                                                                     |
| ScatterElements           | N         |                                                                                                                                                                     |
| ScatterND                 | Y         |                                                                                                                                                                     |
| Selu                      | Y         | Parameters "alpha" and "gamma" must be default                                                                                                                      |
| SequenceAt                | N         |                                                                                                                                                                     |
| SequenceConstruct         | N         |                                                                                                                                                                     |
| SequenceEmpty             | N         |                                                                                                                                                                     |
| SequenceErase             | N         |                                                                                                                                                                     |
| SequenceInsert            | N         |                                                                                                                                                                     |
| SequenceLength            | N         |                                                                                                                                                                     |
| Shape                     | Y         |                                                                                                                                                                     |
| Shrink                    | N         |                                                                                                                                                                     |
| Sigmoid                   | Y         |                                                                                                                                                                     |
| Sign                      | Y         |                                                                                                                                                                     |
| Sin                       | Y         |                                                                                                                                                                     |
| Sinh                      | N         |                                                                                                                                                                     |
| Size                      | N         |                                                                                                                                                                     |
| Slice                     | Y         |                                                                                                                                                                     |
| Softplus                  | Y         |                                                                                                                                                                     |
| Softsign                  | Y         |                                                                                                                                                                     |
| SpaceToDepth              | N         |                                                                                                                                                                     |
| Split                     | Y         |                                                                                                                                                                     |
| SplitToSequence           | N         |                                                                                                                                                                     |
| Sqrt                      | Y         |                                                                                                                                                                     |
| Squeeze                   | Y         |                                                                                                                                                                     |
| StringNormalizer          | N         |                                                                                                                                                                     |
| Sub                       | Y         |                                                                                                                                                                     |
| Sum                       | Y         |                                                                                                                                                                     |
| Tan                       | Y         |                                                                                                                                                                     |
| Tanh                      | Y         |                                                                                                                                                                     |
| TfIdfVectorizer           | N         |                                                                                                                                                                     |
| ThresholdedRelu           | N         |                                                                                                                                                                     |
| Tile                      | Y         |                                                                                                                                                                     |
| TopK                      | Y         |                                                                                                                                                                     |
| Transpose                 | Y         |                                                                                                                                                                     |
| Trilu                     | N         |                                                                                                                                                                     |
| Unique                    | N         |                                                                                                                                                                     |
| Unsqueeze                 | Y         |                                                                                                                                                                     |
| Upsample(deprecated)      | N         |                                                                                                                                                                     |
| Where                     | Y         |                                                                                                                                                                     |
| Xor                       | Y         |                                                                                                                                                                     |
| Function                  | N         |                                                                                                                                                                     |
| Bernoulli                 | N         |                                                                                                                                                                     |
| CastLike                  | N         |                                                                                                                                                                     |
| Celu                      | Y         |                                                                                                                                                                     |
| DynamicQuantizeLinear     | N         |                                                                                                                                                                     |
| GreaterOrEqual            | Y         |                                                                                                                                                                     |
| HardSwish                 | Y         |                                                                                                                                                                     |
| LessOrEqual               | Y         |                                                                                                                                                                     |
| LogSoftmax                | Y         |                                                                                                                                                                     |
| MeanVarianceNormalization | N         |                                                                                                                                                                     |
| NegativeLogLikelihoodLoss | N         |                                                                                                                                                                     |
| Range                     | Y         |                                                                                                                                                                     |
| SequenceMap               | N         |                                                                                                                                                                     |
| Softmax                   | Y         |                                                                                                                                                                     |
